diff --git a/libr/anal/op.c b/libr/anal/op.c
index bde5872631d..5ff6b727333 100644
--- a/libr/anal/op.c
+++ b/libr/anal/op.c
@@ -548,6 +548,9 @@ R_API const char *r_anal_op_family_to_string(int n) {
 	case R_ANAL_OP_FAMILY_MMX: return "mmx";
 	case R_ANAL_OP_FAMILY_SSE: return "sse";
 	case R_ANAL_OP_FAMILY_PRIV: return "priv";
+	case R_ANAL_OP_FAMILY_THREAD: return "thrd";
+	case R_ANAL_OP_FAMILY_CRYPTO: return "crpt";
+	case R_ANAL_OP_FAMILY_IO: return "io";
 	case R_ANAL_OP_FAMILY_VIRT: return "virt";
 	default:
 		snprintf (num, sizeof (num), "%d", n);
@@ -564,6 +567,9 @@ R_API int r_anal_op_family_from_string(const char *f) {
 	if (!strcmp (f, "sse")) return R_ANAL_OP_FAMILY_SSE;
 	if (!strcmp (f, "priv")) return R_ANAL_OP_FAMILY_PRIV;
 	if (!strcmp (f, "virt")) return R_ANAL_OP_FAMILY_VIRT;
+	if (!strcmp (f, "crpt")) return R_ANAL_OP_FAMILY_CRYPTO;
+	if (!strcmp (f, "io")) return R_ANAL_OP_FAMILY_IO;
+	if (!strcmp (f, "thrd")) return R_ANAL_OP_FAMILY_THREAD;
 	return R_ANAL_OP_FAMILY_UNKNOWN;
 }
 
diff --git a/libr/anal/p/anal_arm_cs.c b/libr/anal/p/anal_arm_cs.c
index de976775dd9..192d429b691 100644
--- a/libr/anal/p/anal_arm_cs.c
+++ b/libr/anal/p/anal_arm_cs.c
@@ -970,6 +970,8 @@ static int analop64_esil(RAnal *a, RAnalOp *op, ut64 addr, const ut8 *buf, int l
 	case ARM64_INS_DMB:
 	case ARM64_INS_DSB:
 	case ARM64_INS_ISB:
+		op->family = R_ANAL_OP_FAMILY_THREAD;
+		// intentional fallthrough
 	case ARM64_INS_IC: // instruction cache invalidate
 	case ARM64_INS_DC: // data cache invalidate
 		op->type = R_ANAL_OP_TYPE_SYNC; // or cache
@@ -1944,6 +1946,11 @@ r4,r5,r6,3,sp,[*],12,sp,+=
 		r_strbuf_appendf (&op->esil, "%s,%d,+,[1],%s,=",
 			MEMBASE(1), MEMDISP(1), REG(0));
 		break;
+	case ARM_INS_LDREXB:
+	case ARM_INS_LDREXD:
+	case ARM_INS_LDREXH:
+		op->family = R_ANAL_OP_FAMILY_THREAD;
+		// intentional fallthrough
 	case ARM_INS_LDRHT:
 	case ARM_INS_LDRH:
 	case ARM_INS_LDRT:
@@ -1952,9 +1959,6 @@ r4,r5,r6,3,sp,[*],12,sp,+=
 	case ARM_INS_LDRSBT:
 	case ARM_INS_LDRSH:
 	case ARM_INS_LDRSHT:
-	case ARM_INS_LDREXB:
-	case ARM_INS_LDREXD:
-	case ARM_INS_LDREXH:
 	case ARM_INS_LDR:
 		addr &= ~3LL;
 		if (MEMDISP(1) < 0) {
diff --git a/libr/anal/p/anal_x86_cs.c b/libr/anal/p/anal_x86_cs.c
index 3e46aec88df..022abe025de 100644
--- a/libr/anal/p/anal_x86_cs.c
+++ b/libr/anal/p/anal_x86_cs.c
@@ -1,4 +1,4 @@
-/* radare2 - LGPL - Copyright 2013-2017 - pancake */
+/* radare2 - LGPL - Copyright 2013-2018 - pancake */
 
 #include <r_anal.h>
 #include <r_lib.h>
@@ -2667,6 +2667,7 @@ static int analop(RAnal *a, RAnalOp *op, ut64 addr, const ut8 *buf, int len) {
 			break;
 		case X86_PREFIX_LOCK:
 			op->prefix |= R_ANAL_OP_PREFIX_LOCK;
+			op->family = R_ANAL_OP_FAMILY_THREAD; // XXX ?
 			break;
 		}
 		anop (a, op, addr, buf, len, &handle, insn);
diff --git a/libr/asm/p/asm_x86_cs.c b/libr/asm/p/asm_x86_cs.c
index 40a75c822ea..58eaa9309a9 100644
--- a/libr/asm/p/asm_x86_cs.c
+++ b/libr/asm/p/asm_x86_cs.c
@@ -1,4 +1,4 @@
-/* radare2 - LGPL - Copyright 2013-2016 - pancake */
+/* radare2 - LGPL - Copyright 2013-2018 - pancake */
 
 #include <r_asm.h>
 #include <r_lib.h>
diff --git a/libr/core/cmd_anal.c b/libr/core/cmd_anal.c
index 2c7ae667003..30743135a82 100644
--- a/libr/core/cmd_anal.c
+++ b/libr/core/cmd_anal.c
@@ -1334,6 +1334,15 @@ static void core_anal_bytes(RCore *core, const ut8 *buf, int len, int nops, int
 		char *sp = strchr (mnem, ' ');
 		if (sp) {
 			*sp = 0;
+			if (op.prefix) {
+				char *arg = strdup (sp + 1);
+				char *sp = strchr (arg, ' ');
+				if (sp) {
+					*sp = 0;
+				}
+				free (mnem);
+				mnem = arg;
+			}
 		}
 		if (ret < 1 && fmt != 'd') {
 			eprintf ("Oops at 0x%08" PFMT64x " (", core->offset + idx);
diff --git a/libr/include/r_anal.h b/libr/include/r_anal.h
index 40329333ae2..94b28ff787a 100644
--- a/libr/include/r_anal.h
+++ b/libr/include/r_anal.h
@@ -347,6 +347,7 @@ enum {
 	R_ANAL_OP_FAMILY_SSE,    /* extended multimedia instruction (packed data) */
 	R_ANAL_OP_FAMILY_PRIV,   /* priviledged instruction */
 	R_ANAL_OP_FAMILY_CRYPTO, /* cryptographic instructions */
+	R_ANAL_OP_FAMILY_THREAD, /* thread/lock/sync instructions */
 	R_ANAL_OP_FAMILY_VIRT,   /* virtualization instructions */
 	R_ANAL_OP_FAMILY_IO,     /* IO instructions (i.e. IN/OUT) */
 	R_ANAL_OP_FAMILY_LAST
